#-*- coding: utf-8 -*-

from pyeole.process import system_out
from utils import repr_value, eole23_version
from subprocess import Popen, PIPE
import shlex

def get_values(variables, empty=False):
    """
    Provides values corresponding to variables executing shell functions.
    :param variables: set of variable name and function to execute
    :type variables: (str, str)
    :param empty: wether to keep variables for which function return nothing valuable
    :type empty: bool
    """
    values = {}
    for variable in variables:
        commands = variable[1].split('|')
        variable = variable[0]
        if len(commands) > 1:
            commands = [shlex.split(c) for c in commands]
            processes = []
            processes.append(Popen(commands[0], stdout=PIPE))
            for command in commands[1:]:
                processes.append(Popen(command, stdin= processes[-1].stdout, stdout=PIPE))
            output = processes[-1].communicate()[0]
        else:
            code, output, err = system_out(shlex.split(commands[0]))
        if empty or output != '':
            values[variable] = repr_value(eole23_version(output))
    return values
