#-*- coding: utf-8 -*-

from utils import repr_value

default_value = None
try:
    from zephir.zephir_conf import zephir_conf as config
except ImportError:
    default_value = 'non enregistré sur le Zéphir'

def get_values(variables, empty=False):
    """
    Provides values corresponding to variables importing zephir configuration.
    :param variables: set of variable name and function to execute
    :type variables: (str, str)
    :param empty: wether to keep variables for which zephir configuration contains nothing valuable
    :type empty: bool
    """
    values = {}
    if default_value is None:
        for variable in variables:
            value = variable[1]
            try:
                value = repr_value(getattr(config, value))
                if empty or value != '':
                    values[variable[0]] = value
            except AttributeError:
                pass
    return values

